Index: benchmark/bfs-bench.cc
===================================================================
--- benchmark/bfs-bench.cc	(revision 2553)
+++ benchmark/bfs-bench.cc	(revision 2569)
@@ -18,5 +18,5 @@
 
 #include<queue>
-#include<cmath>
+#include<lemon/math.h>
 #include<lemon/smart_graph.h>
 #include"bench_tools.h"
Index: benchmark/hcube.cc
===================================================================
--- benchmark/hcube.cc	(revision 2553)
+++ benchmark/hcube.cc	(revision 2569)
@@ -17,5 +17,5 @@
  */
 
-#include<cmath>
+#include<lemon/math.h>
 #include<lemon/list_graph.h>
 #include<lemon/smart_graph.h>
Index: benchmark/radix_sort-bench.cc
===================================================================
--- benchmark/radix_sort-bench.cc	(revision 2553)
+++ benchmark/radix_sort-bench.cc	(revision 2569)
@@ -31,5 +31,5 @@
 #include <vector>
 #include <algorithm>
-#include <cmath>
+#include <lemon/math.h>
 
 using namespace std;
Index: demo/descriptor_map_demo.cc
===================================================================
--- demo/descriptor_map_demo.cc	(revision 2568)
+++ demo/descriptor_map_demo.cc	(revision 2569)
@@ -37,5 +37,5 @@
 #include <iostream>
 
-#include <cmath>
+#include <lemon/math.h>
 
 
Index: demo/eps_demo.cc
===================================================================
--- demo/eps_demo.cc	(revision 2568)
+++ demo/eps_demo.cc	(revision 2569)
@@ -28,5 +28,5 @@
 /// \include eps_demo.cc
 
-#include <cmath>
+#include <lemon/math.h>
 #include <lemon/eps.h>
 
Index: demo/graph_to_eps_demo.cc
===================================================================
--- demo/graph_to_eps_demo.cc	(revision 2553)
+++ demo/graph_to_eps_demo.cc	(revision 2569)
@@ -31,5 +31,5 @@
 /// \include graph_to_eps_demo.cc
 
-#include <cmath>
+#include <lemon/math.h>
 
 #include<lemon/graph_to_eps.h>
Index: demo/min_route.cc
===================================================================
--- demo/min_route.cc	(revision 2553)
+++ demo/min_route.cc	(revision 2569)
@@ -28,5 +28,5 @@
 #include <lemon/time_measure.h>
 
-#include <cmath>
+#include <lemon/math.h>
 
 /// \ingroup demos
Index: demo/steiner_demo.cc
===================================================================
--- demo/steiner_demo.cc	(revision 2553)
+++ demo/steiner_demo.cc	(revision 2569)
@@ -30,9 +30,8 @@
 #include <lemon/time_measure.h>
 #include <lemon/graph_to_eps.h>
-
 #include <lemon/steiner.h>
+#include <lemon/math.h>
 
 #include <cstdlib>
-#include <cmath>
 
 using namespace lemon;
Index: lemon/color.h
===================================================================
--- lemon/color.h	(revision 2553)
+++ lemon/color.h	(revision 2569)
@@ -21,5 +21,5 @@
 
 #include<vector>
-#include<cmath>
+#include<lemon/math.h>
 #include<lemon/maps.h>
 
Index: lemon/fib_heap.h
===================================================================
--- lemon/fib_heap.h	(revision 2553)
+++ lemon/fib_heap.h	(revision 2569)
@@ -26,5 +26,5 @@
 #include <vector>
 #include <functional>
-#include <cmath>
+#include <lemon/math.h>
 
 namespace lemon {
Index: lemon/full_graph.h
===================================================================
--- lemon/full_graph.h	(revision 2553)
+++ lemon/full_graph.h	(revision 2569)
@@ -20,5 +20,5 @@
 #define LEMON_FULL_GRAPH_H
 
-#include <cmath>
+#include <lemon/math.h>
 
 #include <lemon/bits/base_extender.h>
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 2553)
+++ lemon/graph_to_eps.h	(revision 2569)
@@ -32,7 +32,7 @@
 #include<vector>
 
-#include <ctime>
-#include <cmath>
-
+#include<ctime>
+
+#include<lemon/math.h>
 #include<lemon/bits/invalid.h>
 #include<lemon/dim2.h>
Index: lemon/graph_utils.h
===================================================================
--- lemon/graph_utils.h	(revision 2553)
+++ lemon/graph_utils.h	(revision 2569)
@@ -23,5 +23,5 @@
 #include <vector>
 #include <map>
-#include <cmath>
+#include <lemon/math.h>
 #include <algorithm>
 
Index: lemon/lp_base.h
===================================================================
--- lemon/lp_base.h	(revision 2553)
+++ lemon/lp_base.h	(revision 2569)
@@ -24,5 +24,5 @@
 #include<map>
 #include<limits>
-#include<cmath>
+#include<lemon/math.h>
 
 #include<lemon/error.h>
Index: lemon/network_simplex.h
===================================================================
--- lemon/network_simplex.h	(revision 2556)
+++ lemon/network_simplex.h	(revision 2569)
@@ -48,5 +48,5 @@
 
 #ifdef EDGE_BLOCK_PIVOT
-  #include <cmath>
+  #include <lemon/math.h>
   #define MIN_BLOCK_SIZE        10
 #endif
Index: lemon/random.h
===================================================================
--- lemon/random.h	(revision 2568)
+++ lemon/random.h	(revision 2569)
@@ -68,6 +68,6 @@
 
 #include <ctime>
-#include <cmath>
-
+
+#include <lemon/math.>
 #include <lemon/dim2.h>
 ///\ingroup misc
Index: lemon/simann.h
===================================================================
--- lemon/simann.h	(revision 2553)
+++ lemon/simann.h	(revision 2569)
@@ -29,5 +29,5 @@
 
 #include <cstdlib>
-#include <cmath>
+#include <lemon/math.h>
 #include <limits>
 #include <lemon/time_measure.h>
Index: test/all_pairs_shortest_path_test.cc
===================================================================
--- test/all_pairs_shortest_path_test.cc	(revision 2553)
+++ test/all_pairs_shortest_path_test.cc	(revision 2569)
@@ -20,5 +20,5 @@
 #include <vector>
 
-#include <cmath>
+#include <lemon/math.h>
 #include <cstdlib>
 
Index: test/arborescence_test.cc
===================================================================
--- test/arborescence_test.cc	(revision 2553)
+++ test/arborescence_test.cc	(revision 2569)
@@ -22,5 +22,5 @@
 #include <iterator>
 
-#include <cmath>
+#include <lemon/math.h>
 #include <cstdlib>
 
Index: test/max_matching_test.cc
===================================================================
--- test/max_matching_test.cc	(revision 2553)
+++ test/max_matching_test.cc	(revision 2569)
@@ -20,5 +20,5 @@
 #include <vector>
 #include <queue>
-#include <cmath>
+#include <lemon/math.h>
 #include <cstdlib>
 
Index: test/max_weighted_matching_test.cc
===================================================================
--- test/max_weighted_matching_test.cc	(revision 2553)
+++ test/max_weighted_matching_test.cc	(revision 2569)
@@ -21,5 +21,5 @@
 #include <vector>
 #include <queue>
-#include <cmath>
+#include <lemon/math.h>
 #include <cstdlib>
 
Index: test/radix_sort_test.cc
===================================================================
--- test/radix_sort_test.cc	(revision 2553)
+++ test/radix_sort_test.cc	(revision 2569)
@@ -28,5 +28,5 @@
 #include <vector>
 #include <algorithm>
-#include <cmath>
+#include <lemon/math.h>
 
 using namespace std;
Index: tools/lgf-gen.cc
===================================================================
--- tools/lgf-gen.cc	(revision 2553)
+++ tools/lgf-gen.cc	(revision 2569)
@@ -82,5 +82,5 @@
 #include <lemon/arg_parser.h>
 #include <lemon/euler.h>
-#include <cmath>
+#include <lemon/math.h>
 #include <algorithm>
 #include <lemon/kruskal.h>